//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "CustomCard.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TCustomCard *)
{
	new TCustomCard(NULL);
}
//---------------------------------------------------------------------------
__fastcall TCustomCard::TCustomCard(TComponent* Owner)
	: TCustomControl(Owner)
{
	Width=71;
  Height=96;
  DragMode=dmAutomatic;
  FShowFace=True;
  FCard="CL_0";
  FCardSuit=Clubs;
  FCardValue=Ace;
  FBack=Apple;
  Invalidate();
}

void __fastcall TCustomCard::Paint(void)
{
  AnsiString CardBuffer;
  if(FShowFace) CardBuffer=FCard;
  else CardBuffer = "BK_"+IntToStr(FBack);
	Graphics::TBitmap *Bitmap1 = new Graphics::TBitmap();
	Bitmap1->LoadFromResourceName((int)HInstance,CardBuffer);
  Canvas->Draw(0,0,Bitmap1);
  delete Bitmap1;
}

void __fastcall TCustomCard::SetCard(AnsiString ACard)
{
  if(FCard!=ACard)
  {
    FCard=ACard;
    Invalidate();
  }
}

void __fastcall TCustomCard::SetBack(TCardBack ABack)
{
  if(FBack!=ABack)
  {
    FBack=ABack;
    Invalidate();
  }
}

void __fastcall TCustomCard::FlipCard(bool ADisplayFace)
{
	if(FShowFace!=ADisplayFace)
  {
  	FShowFace=ADisplayFace;
  	Invalidate();
  }
}

void __fastcall TCustomCard::SetCardSuit(TCardSuit ASuit)
{
  AnsiString SuitString;
  switch (ASuit)
  {
    case 0: SuitString="CL_";
    break;
    case 1: SuitString="DI_";
    break;
    case 2: SuitString="HE_";
    break;
    case 3: SuitString="SP_";
    break;
  }

  if(FCardSuit!=ASuit)
  {
    FCardSuit=ASuit;
    FCard=SuitString+IntToStr(FCardValue);
    Invalidate();
  }
}

void __fastcall TCustomCard::SetCardValue(TCardValue AValue)
{
  AnsiString SuitString;
  switch (FCardSuit)
  {
    case 0: SuitString="CL_";
    break;
    case 1: SuitString="DI_";
    break;
    case 2: SuitString="HE_";
    break;
    case 3: SuitString="SP_";
    break;
  }
  if(FCardValue!=AValue)
  {
    FCardValue=AValue;
    FCard=SuitString+IntToStr(AValue);
    Invalidate();
  }
}
//---------------------------------------------------------------------------
namespace Customcard
{
	void __fastcall PACKAGE Register()
	{
		TComponentClass classes[1] = {__classid(TCustomCard)};
		RegisterComponents("Samples", classes, 0);
	}
}
//---------------------------------------------------------------------------

